/*************************************************************
*   system_check.c  PWM API System All Check  Ver.1.0        *
*                                          Date:14 May 2004  *
*                                Programed by Hiroki.Segawa  *
*************************************************************/

#include <stdio.h>
#include <unistd.h>
#include "../control/func_extern.h"
#include "pwm_enc.h"

int main(){
	int mode,flag,br,i;
	int lduty,rduty,ldis,rdis,dist,radius,angle,tup;
	float alw,arw,omr,oml;
	//int period=peri; /* [20ms] peri defined pwm_enc.h */
	int period=10; /* [10ms] peri defined pwm_enc.h */
	
	while(1){
		i=0;flag=0;lduty=0;rduty=0;ldis=0;rdis=0;radius=0;angle=0;tup=0;
		printf("\n\nPlease Input Mode Number\n");
		printf("1:pwm_both_data check    --> (no control) duty only (-127 to 127)\n");
		printf("2:pwm_straight check     --> (pid control) go straight as far as reserved distance\n");
		printf("3:pwm_rotate check       --> (pid control) rotate on the spot\n");
		printf("4:pwm_lqr_straight check --> (lqr control) go straight as far as reserved distance\n");
		printf("5:pwm_lqr_rotate check   --> (lqr control) rotate on the spot\n");
		printf("6:pwm_lqr_circle check   --> (lqr control) rotate around a something\n");
		printf("7:Exit This Menu\n\nSelect Number = ");
		scanf("%d",&mode);
		printf("\n\n");
		switch(mode){
			case 1:
				printf("Input L_Duty[-127~127] : ");
				scanf("%d",&lduty);
				printf("\nInput R_Duty[-127~127] : ");
				scanf("%d",&rduty);
				pwm_enco_stop();
				pwm_both_data(lduty,rduty);
				pwm_enco_start(period);
				while(i<100){
					encoder_data(&alw,&arw,&oml,&omr,&br);
					i++;
				}
				break;
			case 2:
				printf("Input L_Distance[mm] : ");
				scanf("%d",&ldis);
				printf("\nInput R_Distance[mm] : ");
				scanf("%d",&rdis);
				pwm_enco_stop();
				pwm_straight(ldis,rdis);
				pwm_enco_start(period);
				while(1){
					encoder_data(&alw,&arw,&oml,&omr,&br);
					if(br==1)break;
				}
				break;
			case 3:
				printf("Input Angle[deg] : ");
				scanf("%d",&angle);
				pwm_enco_stop();
				pwm_rotate(angle);
				pwm_enco_start(period);
				while(1){
					encoder_data(&alw,&arw,&oml,&omr,&br);
					if(br==1)break;
				}
				break;
			case 4:
				printf("Input Distance[mm] : ");
				scanf("%d",&dist);
				printf("\nInput Time[msec] : ");
				scanf("%d",&tup);
				pwm_enco_stop();
				pwm_lqr_straight(dist,tup);
				pwm_enco_start(period);
				while(1){
					encoder_data(&alw,&arw,&oml,&omr,&br);
					if(br==1)break;
				}
				break;
			case 5:
				printf("Input Angle[deg] : ");
				scanf("%d",&angle);
				printf("\nInput Time[msec] : ");
				scanf("%d",&tup);
				pwm_enco_stop();
				pwm_lqr_rotate(angle,tup);
				pwm_enco_start(period);
				while(1){
					encoder_data(&alw,&arw,&oml,&omr,&br);
					if(br==1)break;
				}
				break;
			case 6:
				printf("Input Radius of Gyration[mm] : ");
				scanf("%d",&radius);
				printf("\nInput Angle[deg] : ");
				scanf("%d",&angle);
				printf("\nInput Time[msec] : ");
				scanf("%d",&tup);
				pwm_enco_stop();
				pwm_lqr_circle(radius,angle,tup);
				pwm_enco_start(period);
				while(1){
					encoder_data(&alw,&arw,&oml,&omr,&br);
					if(br==1)break;
				}
				break;
			default:
				flag=-999;
				break;
		}
		pwm_both_data(0,0);
		usleep(50000);
		pwm_enco_stop();
		if(flag==-999)break;
	}
	return 0;
}
