#include <stdio.h>
#include <errno.h>
#include <sys/time.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <pthread.h>
#include "uss.h"

void *uss_transmit(int *uss_no)
{
        struct timeval tv;
        struct uss_msg_struct msg;

	int cmd;
	int n;
        fd_set rfds;
        int retval;
        int fd0, ctl;
	int bufsize=10;
	int buf[bufsize];

        msg.command=1; /* Shot */
        msg.number=*uss_no;
        cmd = *uss_no;

	printf("uss_no =%d\n",cmd);

        if ((fd0 = open("/dev/rtf2", O_RDONLY)) < 0) {
                fprintf(stderr, "Error opening /dev/rtf2\n");
                exit(1);
        }

        if ((ctl = open("/dev/rtf1", O_WRONLY)) < 0) {
                fprintf(stderr, "Error opening /dev/rtf1\n");
                exit(1);
        }

        while(1) {
                        if (write(ctl, &msg, sizeof(msg)) < 0){
                                fprintf(stderr, "uss_transmit:now sending commands to uss%d.\n", cmd);
                                continue;
                        }
                        FD_ZERO(&rfds);
                        FD_SET(fd0, &rfds);
                        tv.tv_sec = 0;
                        tv.tv_usec = 100000;

                        retval = select(FD_SETSIZE, &rfds, NULL, NULL, &tv);
                        if (retval > 0) {
                                if (FD_ISSET(fd0, &rfds)) {
                                        n = read(fd0, buf, bufsize - 1);
                                        buf[n] = 0;
                                        uss_data = buf[0];
                                        break;
                                }
                        }
                        else {
                                uss_data = 999;
                                break;
                        }

        }
	close(fd0);
	close(ctl);
        pthread_exit(0);
}
