/*
	Definition major parameters of control program.
	Definition struct variables.
	Declaration of variablae types.
*/
#define POST_NUM 2 		/* total post numbers */ 
/* movement paramter */
#define circle_radious 360	/* circle diameter of going arround a post */
#define post_diameter 200	/* post diameter */
#define PWM_ENC_PERIOD 20	/* RT tsak period of pwm_enc_module2 */
#define FOWARD_DIS 100 		/* Distance to move to the post in circle_position */
/* USS measurment parmeter */
#define USS_MAX 1000		/* POST distace maxmimum */
#define USS_MIN 300 		/* POST distace minimum */
#define MCENTER_USS3_DIS 138		/* Distance between MIRS center and USS3 */
#define MCENTER_USS12_DIS 100		/* Distance between MIRS center and USS1,2 */
#define USS12_DIFF  0		/* USS Diffrence = USS1 - USS2  */
#define USS_CORRECT -30 /* Difference of USS data from correct distance */

// tuning parameter 
#define POST_ANG_DIFF	-14 /* POST angle diffrence in post_search */
#define AROUND_ANG      360-10 /* Rotation Angle around post in post_circle */

// declaration of pthead type */ 
pthread_t uss_task;
pthread_t uss_task2;
pthread_t irs_code_task;
pthread_t irs_ts_ws_task;
pthread_t encoder_task;
pthread_attr_t attr_encoder;
pthread_attr_t attr_irs_ts_ws;
pthread_attr_t attr_uss;

/*
        Definition of stuct variable of post and post_tmp
        variable "post" has data of sevral post information. The data will be
        input during first call of post_search().
        variable "post_tmp" has data of post distance and angle for
        correct_center(). The data will be input during the call of post_search()
        calling after move_center().
*/
struct post{
        int ang[30]; /* post angle */
        int dis[30]; /* distance between post-center and mirs-center */
        int code[30]; /* IRS code of post */
        int got_post[30]; /* flag of post */
        int got_code; /* IRS code number have been got */
        int got_number; /* numbers of posts have been got */
        int number; /* found post numbers */
//        int x[30];		//*************************************************************ɲ
//        int y[30];
//        int direc[30];
//        int level[30];
};

struct post_tmp{
        int ang[30]; /* post angel */
        int dis[30];  /* distance between post-center and mirs-center */
	int number; /* found post numbers */
};

struct sched_param sched_param;
volatile struct count_data count;
volatile struct uss_msg_struct uss_msg;
struct post post;
struct post_tmp post_tmp;

// alw and arw are rotation distance of left and right tire, respectively.
float alw,arw;

int fd0, fd1, fd2, fd3, fd4, fd5, fd6, fd7, ctl;

volatile char irs[4],ts[4],ws[4];       /*tuika*/

int irs_flag,ts_flag,ws_flag;      /*tuika*/
volatile int uss_data;
int target_code;
int return_dist;
int cor_ang;
int uss12;
