/**this is check program if the post exit*/

#include <stdio.h>
#include <errno.h>
#include <sys/time.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <pthread.h>

#include "func_extern.h"
#include "control.h"
#include "pwm_enc.h"
#include "uss.h"

#define SAME_POST 20

//post_check
void post_check(int center_count){

	//variables
	int r_angle;
	int r_time;
	int i;
	int j;
	int k;
	int rot;
	int cd_value;
	int rm_index[10];
	int rm_num = 0;
	int post_angle1[30];
	int post_angle2[30];
	int post_dis1[30];
	int post_dis2[30];
	int diff;
	int dum;
	int angle;
	FILE *fp;
	
	//initialize rm_index[]
 	for(i=0; i<10; i++){
		rm_index[i] = -1;	
	}
		
	count.br = 0;
	usleep(40000);
	printf("check if the post exist.\n");
	
	//post_angle1[] is angle data used in this function.
	//initialize post_angle1[] and post_angle2[]
	//recorde searched post data
	fp=fopen("angle.txt","a");
	printf("file is opend\n");
	for(i=0; i<post.number; i++){
		printf("for\n");
		if(center_count==1){
			post_angle1[i] = post.ang[i];
		}else{
			post_angle1[i] = post_tmp.ang[i];
		}
		post_angle2[i] = 0;
		fprintf(fp,"searched post angle = %d\n",post.ang[i]);		
		printf("searched post angle = %d\n",post.ang[i]);		
	}
	fprintf(fp,"post.number = %d\n",post.number);	
	
	rot=0;
	cor_ang=0;

	//post_check
	//for(i=post.got_number; i<post.number+post.got_number; i++){
	for(i=0; i<post.number; i++){
		if(i==0){
			r_angle = post_angle1[i];	
		}else{
			r_angle = post_angle1[i]-post_angle1[i-1];	
		}

		//rotate forward post
		printf("post_angle at i = %d is %d\n",i,r_angle);
		r_time = r_angle*15;
		pwm_both_data(0,0);
		angle=lqr_rotate(r_angle,r_time);
		if(i==0){
			post_angle1[i]=angle;
		}else{
			post_angle1[i]=angle+post_angle1[i-1];
		}
		printf("angle = %d\n",angle);
		//exit(0);
	
		cd_value = correct_direction1(i);
		
		if(cd_value == -1){//post does not exist.
			pwm_both_data(0,0);
			rm_index[rm_num] = i;
			rm_num++;
		}else if(cd_value == 1){
			pwm_both_data(0,0);
			post_angle1[i] += cor_ang;
			post_dis1[i]=uss12 + USS_CORRECT + MCENTER_USS12_DIS + post_diameter/2;
		printf("cor ang= %d\n",cor_ang);
		}
	}

	r_angle=360-post_angle1[post.number-1];
	r_time=r_angle*15;
	printf("r_angle=%d post_angle1= %d\n",r_angle, post_angle1[post.number-1]);

	lqr_rotate(r_angle,r_time);
	//exit(0);
	
	//renew the angle data
	//call rm_data function
	rm_data(post_angle1,post_angle2,rm_index);
	rm_data(post_dis1,post_dis2,rm_index);
	
	//renew post number
	for(i=post.number-rm_num; i<post.number; i++){
		post.ang[i]=0;
		post.dis[i]=0;
	}
	post.number-=rm_num;
	
	//initialize rm_num
	rm_num = 0;
	//initialize rm_index[]
	for(i=0; i<10; i++){	
		rm_index[i]=-1;
	}
	
	//remove the same data
	//check the same data
	//for(i=post.got_number; i<post.number; i++){
	for(i=0; i<post.number; i++){
		for(j=i+1; j<post.number; j++){
			for(k=0; k<=rm_num; k++){
				if(rm_index[k]==i){
					goto ENDFOR2;
				}	
			}
			diff = abs(post_angle2[i] - post_angle2[j]); 
			if(diff<SAME_POST){
				printf("rm data\n");
				rm_index[rm_num]=j;
				rm_num++;	
			}
		ENDFOR2:
		dum=0;
		}
	//ENDFOR1:
	}

	//renew the angle data
	if(center_count==1){
		rm_data(post_angle2,post.ang,rm_index);
		rm_data(post_dis2,post.dis,rm_index);
	}else{
		rm_data(post_angle2,post_tmp.ang,rm_index);
		rm_data(post_dis2,post_tmp.dis,rm_index);
	}

	//renew the post number and clear not use data
	for(i=post.number-rm_num; i<post.number; i++){
	 	post.ang[i]=0;
		post.dis[i]=0;		
	}
	post.number-=rm_num;
	
	//print data
	//fprintf(fp,"post.got_number = %d\n",post.got_number);
	if(center_count==1){
		for(i=0;i<post.number;i++){
			printf("checked post angle = %d\n",post.ang[i]);
			fprintf(fp,"checked post angle = %d\n",post.ang[i]);
		}
	}else{
		for(i=0;i<post.number;i++){
			printf("checked post angle = %d\n",post_tmp.ang[i]);
			fprintf(fp,"checked post angle = %d\n",post_tmp.ang[i]);
		}
	}
	fprintf(fp,"checked post number = %d\n",post.number);
	//close file
	fclose(fp);
}
