#include "mirs_head.h"
#include "define.h"

#define BAUDRATE B19200
#define MODEMDEVICE "/dev/ttyS0"

static struct termios oldtio,newtio;
static struct timeval tv;
static fd_set rfds;

static int fd_i2c;

void port_open(void){
	char data[127];

    /*ǥХ֥å󥰥⡼ɤǥץ󤹤*/
	fd_i2c = open(MODEMDEVICE, O_RDWR | O_NOCTTY);
	if (fd_i2c <0) {perror(MODEMDEVICE); exit(-1); }
	printf("\n");
	printf(":: serial pord opened\n");
	printf(":: file descriptor = %d\n",fd_i2c);

    /*եǥץƱ⡼ɤˤ*/
	fcntl(fd_i2c, F_SETFL, FASYNC);
	tcgetattr(fd_i2c,&oldtio); /* save current port settings */

    /*󥫥Υ˥⡼*/
	bzero(&newtio, sizeof(newtio));
//	newtio.c_cflag = BAUDRATE | CRTSCTS | CS8 | CLOCAL | CREAD;
	//ܡ졼ȡե楪ʸǥ̵롡ͭ
	newtio.c_cflag = BAUDRATE | CS8 | CLOCAL | CREAD;
	//ܡ졼ȡե椪աʸǥ̵롡ͭ
	newtio.c_iflag = IGNPAR;
	//ե졼२顼ӥѥƥ顼̵뤹롣
	newtio.c_oflag = 0;
	

    /* set input mode (non-canonical, no echo,...) */
	newtio.c_lflag = 0;
	newtio.c_cc[VTIME]    = 0;   /* 饯֥ޤ̤ */
	newtio.c_cc[VMIN]     = 6;   /* 255ʸޤǼ*/
 
	tcflush(fd_i2c, TCIFLUSH); //ɤǤʤǡեå夹롣
	tcsetattr(fd_i2c,TCSANOW,&newtio); //äꤷѥ᡼򤿤ͭȤ롣
	printf(":: serial port initialized\n");	
	printf("\n");
	
	strcpy(data,"* DM FB t0x01 @21 w47_74_51_41 \r\n");
	//Ԥ֤01[HEX]*200ޥ DM˥ ϣɽ
	//I2Cɥ쥹Gޥɡ쥸ɥ쥹ꡡquery⡼ɡAޥ
	write(fd_i2c,data,strlen(data));
	printf("%s\n",data);

	usleep(50000);		//Aޥɤθ6msɬ	50msޤäȤ

	read_compass();
	usleep(50000);
	direc0=read_compass();	//ܤη¬
	printf("direc0:%d\n",direc0);
	usleep(50000);
}

void set_led(void){
	char data[127],buf[127];
	int i,n,retval;
//ǡä	
	//졼֥ɥ쥹60(HEX) (A0-A2low)ξ
	strcpy(data,"w@60 w12");
	
	strcat(data," w");
	strcat(data,blink1);
	strcat(data," w");
	strcat(data,duty1);
	strcat(data," w");
	strcat(data,blink2);
	strcat(data," w");
	strcat(data,duty2);

/*						//16ɽˤΤǾάǽ
	strcat(data,"\r\n");
	write(fd_i2c,data,strlen(data));
	printf("%s",data);
	usleep(50000);	//50msԤ
	strcpy(data,"");	//data
*/
	
	n=0;			//n
	for(i=3;i>=0;i--){
		switch (led[i]) {
			case 1:
				n+=0;		//ȣϵդˤȤ狼䤹
				break;
			case 0:
				n+=1;
				break;
			case 2:
				n+=2;
				break;
			case 3:
				n+=3;
				break;
		}
		if(i>0){n*=4;}		//Ǹηi==0ˤΤȤϣܤʤ
	}
	sprintf(buf," w%02x",n);//nƤ򣱣ʤbuf
	strcat(data,buf);	//bufdataθˤäĤ
	
	
	n=0;			//n
	for(i=7;i>=4;i--){
		switch (led[i]) {
			case 1:
				n+=0;		//ȣϵդˤȤ狼䤹
				break;
			case 0:
				n+=1;
				break;
			case 2:
				n+=2;
				break;
			case 3:
				n+=3;
				break;
		}
		if(i>4){n*=4;}		//ǸηΤȤϣܤʤ
	}
	sprintf(buf," w%02x",n);	//nƤ򣱣ʤbuf
	strcat(data,buf);		//bufdataθˤäĤ
	
	
	n=0;			//n
	for(i=11;i>=8;i--){
		switch (led[i]) {
			case 1:
				n+=0;		//ȣϵդˤȤ狼䤹
				break;
			case 0:
				n+=1;
				break;
			case 2:
				n+=2;
				break;
			case 3:
				n+=3;
				break;
		}
		if(i>8){n*=4;}		//ǸηΤȤϣܤʤ
	}
	sprintf(buf," w%02x",n);	//nƤ򣱣ʤbuf
	strcat(data,buf);		//bufdataθˤäĤ
	
	
	n=0;			//n
	for(i=15;i>=12;i--){
		switch (led[i]) {
			case 1:
				n+=0;		//ȣϵդˤȤ狼䤹
				break;
			case 0:
				n+=1;
				break;
			case 2:
				n+=2;
				break;
			case 3:
				n+=3;
				break;
		}
		if(i>12){n*=4;}		//ǸηΤȤϣܤʤ
	}
	sprintf(buf," w%02x",n);	//nƤ򣱣ʤbuf
	strcat(data,buf);		//bufdataθˤäĤ
	
	strcat(data," p\r\n");
	write(fd_i2c,data,strlen(data));
	printf("%s",data);
}

int read_compass(int cor_flag){
	char buf[127],data[127];
	int i,msd,lsd,byte,ang,got;
	int retval;

	/*selectǻȤΤѰ*/	
	FD_ZERO(&rfds);		//rfdsõ
	FD_SET(fd_i2c, &rfds);	//fdrfdsɲ
	tv.tv_sec=1;		//ॢȣä
	tv.tv_usec=0;
	
	tcflush(fd_i2c, TCIFLUSH); //ɤǤʤǡեå夹롣

//ǡ
	strcpy(data,"r@21 r2p\r\n");
	write(fd_i2c,data,strlen(data));

	retval = select(5, &rfds, NULL, NULL, &tv);	// ॢ1äǥ֥å
	if(retval > 0){
		byte = read(fd_i2c,buf,6);
	}
	else{
		printf("timeout\n");
		return(9999);
	}

	got=0;
	
//4	MSD
	switch (buf[1]) {
		case '0':
			break;
		case '1':
			got += 1 * pow(16,3);
			break;
		case '2':
			got += 2 * pow(16,3);
			break;
		case '3':
			got += 3 * pow(16,3);
			break;
		case '4':
			got += 4 * pow(16,3);
			break;
		case '5':
			got += 5 * pow(16,3);
			break;
		case '6':
			got += 6 * pow(16,3);
			break;
		case '7':
			got += 7 * pow(16,3);
			break;
		case '8':
			got += 8 * pow(16,3);
			break;
		case '9':
			got += 9 * pow(16,3);
			break;
		case 'a':
			got += 10 * pow(16,3);
			break;
		case 'b':
			got += 11 * pow(16,3);
			break;
		case 'c':
			got += 12 * pow(16,3);
			break;
		case 'd':
			got += 13 * pow(16,3);
			break;
		case 'e':
			got += 14 * pow(16,3);
			break;
		case 'f':
			got += 15 * pow(16,3);
			break;
		default:
			printf("16NUMBER ERROR \n");
			return(9999);
			break;
	}

//3
	switch (buf[2]) {
		case '0':
			break;
		case '1':
			got += 1 * pow(16,2);
			break;
		case '2':
			got += 2 * pow(16,2);
			break;
		case '3':
			got += 3 * pow(16,2);
			break;
		case '4':
			got += 4 * pow(16,2);
			break;
		case '5':
			got += 5 * pow(16,2);
			break;
		case '6':
			got += 6 * pow(16,2);
			break;
		case '7':
			got += 7 * pow(16,2);
			break;
		case '8':
			got += 8 * pow(16,2);
			break;
		case '9':
			got += 9 * pow(16,2);
			break;
		case 'a':
			got += 10 * pow(16,2);
			break;
		case 'b':
			got += 11 * pow(16,2);
			break;
		case 'c':
			got += 12 * pow(16,2);
			break;
		case 'd':
			got += 13 * pow(16,2);
			break;
		case 'e':
			got += 14 * pow(16,2);
			break;
		case 'f':
			got += 15 * pow(16,2);
			break;
		default:
			printf("16NUMBER ERROR \n");
			return(9999);
			break;
	}

//2
	switch (buf[4]) {
		case '0':
			break;
		case '1':
			got += 1 * pow(16,1);
			break;
		case '2':
			got += 2 * pow(16,1);
			break;
		case '3':
			got += 3 * pow(16,1);
			break;
		case '4':
			got += 4 * pow(16,1);
			break;
		case '5':
			got += 5 * pow(16,1);
			break;
		case '6':
			got += 6 * pow(16,1);
			break;
		case '7':
			got += 7 * pow(16,1);
			break;
		case '8':
			got += 8 * pow(16,1);
			break;
		case '9':
			got += 9 * pow(16,1);
			break;
		case 'a':
			got += 10 * pow(16,1);
			break;
		case 'b':
			got += 11 * pow(16,1);
			break;
		case 'c':
			got += 12 * pow(16,1);
			break;
		case 'd':
			got += 13 * pow(16,1);
			break;
		case 'e':
			got += 14 * pow(16,1);
			break;
		case 'f':
			got += 15 * pow(16,1);
			break;
		default:
			printf("16NUMBER ERROR \n");
			return(9999);
			break;
	}
//ᡡLSD
	switch (buf[5]) {
		case '0':
			break;
		case '1':
			got += 1;
			break;
		case '2':
			got += 2;
			break;
		case '3':
			got += 3;
			break;
		case '4':
			got += 4;
			break;
		case '5':
			got += 5;
			break;
		case '6':
			got += 6;
			break;
		case '7':
			got += 7;
			break;
		case '8':
			got += 8;
			break;
		case '9':
			got += 9;
			break;
		case 'a':
			got += 10;
			break;
		case 'b':
			got += 11;
			break;
		case 'c':
			got += 12;
			break;
		case 'd':
			got += 13;
			break;
		case 'e':
			got += 14;
			break;
		case 'f':
			got += 15;
			break;
		default:
			printf("16NUMBER ERROR \n");
			return(9999);
			break;
	}

/*	
	retval = sscanf(buf,"%x %x",&msd,&lsd);	//16ɽѴ
	if(retval != 2){			//16ʿĤȤʤä
		printf("16NUMBER ERROR \n");
		return(9999);
	}
	
	got = msd*16 + lsd;	//̷1byte򣱣ܤ­
*/	
	
	ang=-((got/10)-359);	//ˤơǳ0-3599  0-359ˤ
	
	if(ang<=180){ang -= (20.0/180.0)*ang;}else{ang -= (20.0/180.0)*(360-ang);}
	if(ang<0){ang+=360;}
	
	if(cor_flag==1){
		ang=ang-direc0;		//Ȼ̤0ˤ褦
		if(ang<0){ang+=360;}
	}
	
	return(ang);
}



void port_close(void){
    /*ץ೫ϻΥݡ*/
	//tcsetattr(fd_i2c,TCSANOW,&oldtio);
	pthread_cancel(compass_task);
	printf(":: compass thread canceled\n");
	close(fd_i2c);
	printf(":: serial port closed\n");
}

